// This function returns the derivative of f calculated simply applying the definition, with step h 
function derive (function f , float h ) 
{
	function f1 = lambda ( float x ) { return (f(x + h ) - f(x ))/h ; } ;
	return f1 ;
}

//This function returns the derivative of f calculated by a better algorhytm.
function derive2 (function f, float h) 
{
	function f1 = lambda ( float  x ) {  return (f (x + h ) - f (x - h)) / ( 2.0 * h) ; } ;
	return f1 ;
}

int main ()
{
	function cosp = derive(cos, 0.01);
	function cosp2 = derive2(cos, 0.01);
	write("cosp(0) = " + cosp(0.0) + ", cosp(1.72) = " + cosp(1.72) + "\n" ) ;
	write("cosp2(0) + " + cosp2(0.0) + ", cosp2(1.72) = " + cosp2(1.72) + "\n");
	return 0;
}
