import .LinearAlgebra ;
// Els arrays son en columna, excepte f que s una fila

array LinearLeastSquares( NMatrix xdata , NMatrix ydata , NMatrix error_ydata , array f )
{
  int lon_x = xdata->rows();
  int lon_y = ydata->rows();
  int lon_err = error_ydata->rows();
  function funcioneta ;
  if ( lon_x != lon_y || lon_x != lon_err || lon_y != lon_err ) //Ac cal carregar una excepci
    {
      return ({-1});
    }
  else
    {
      int lon_f = sizeof(f);
      NMatrix v1 = NMatrix(lon_y, lon_y);
      array v = v1->cast("array");
      NMatrix a1 = NMatrix( lon_x ,  lon_f ) ;
      array a = a1->cast("array");
      array error_y = error_ydata->cast("array");
      array x = xdata->cast("array");
      array y = ydata->cast("array");
      for ( int i = 0 ; i < lon_x ; ++i )
	{
	  for ( int j = 0 ; j < lon_f ; ++j )
	    {
	      funcioneta = f[j] ;
	      a[i][j] = funcioneta ( x[i][0] );
	    }
	}
      for ( int i = 0 ; i < lon_x  ; ++i )
	{
	  v[i][i] = pow(error_y[i][0] ,2 )  ;
	}
      v1 = NMatrix(v);
      a1 = NMatrix(a);
      NMatrix v_1 = v1->inverse();
      NMatrix v_1a = v_1->mult(a1) ;
      NMatrix a1t = a1->transpose();
      NMatrix atv_1a =  a1t->mult(v_1a ) ;
      NMatrix c = atv_1a->inverse();
      NMatrix v_1y = v1->inverse()->mult(ydata);
      NMatrix coeficients = c->mult( a1->transpose() )->mult(v_1y) ;
      return ({coeficients, c } );
    }
}

array LinearLeastSquaresStraightLine ( NMatrix xdata, NMatrix ydata, NMatrix error_ydata ) 
{
  function f1, f2 ;
  f1 = lambda (int|float x ) { return x ; } ;
  f2 = lambda (int|float x ) { return 1.0 ; } ;
  array resultat = LinearLeastSquares ( xdata, ydata, error_ydata , ({ f1, f2 } ) ) ;
  float pendent = resultat[0]->get(0, 0) ;
  float ordenada = resultat[0]->get(1,0) ;
  float error_pendent = sqrt(resultat[1]->get(0,0)) ;
  float error_ord = sqrt(resultat[1]->get(1,1)) ;
  return ({ pendent, ordenada, error_pendent, error_ord } ) ;
}


int main ()
{
  function f1 = lambda (float|int x ) { return x ; } ;
  function f2 = lambda (float|int  x ) { return 1.0 ; } ;
  array xaux =  ( { ( { 1.0 } ) , ( { 2.0 } ) , ({ 3.0})  , ({ 4.0 }) } ) ;
  NMatrix x = NMatrix ( xaux ) ;
  NMatrix y = NMatrix ( ({ ({ 3.0 }) , ({ 5.0 }) , ({ 7.0}) , ({ 9.0}) }) ) ;
  NMatrix error_y = NMatrix ( ({ ({ 0.03 }) , ({ 0.05 }) , ({ 0.07 }) , ({ 0.09 }) }) ) ;
  array f = ( { f1,  f2 } ) ; 
  write("Testing LeastSquares\n");
  array resultat = LinearLeastSquares( x, y , error_y, f );
  write("Parmetres:\n");
  resultat[0]->show();
  write("Matriu de covariana:\n");
  resultat[1]->show();
  resultat = LinearLeastSquaresStraightLine( x, y , error_y ) ;
  write("Pendent : " + resultat[0] + " +- " + resultat[2] + " , ordenada : " + resultat[1] + " +- " + resultat[3] + "\n" );
}
